define([
        "dojo/_base/declare",
        "dojo/store/util/QueryResults",
        "aps/SimpleQueryEngine",
        "./ExtendedStore.js"
], function (
    declare,
    QueryResults,
    SimpleQueryEngine,
    ExtendedStore
) {

return declare([ExtendedStore], {
	queryEngine: SimpleQueryEngine,
	queryCallback: function(remoteQuery, remoteOptions) {
	    // function(remoteQuery, remoteOptions, resultQuery, resultOptions)
	    this.inherited(arguments);
	    delete remoteOptions["sort"];
	    delete remoteOptions["start"];
	    delete remoteOptions["count"];
	},
	itemsCallback: function(items, query, options) {
		var list = this.inherited(arguments);
		if (this.customColumns != null) {
			for (var key in this.customColumns) {
				if(this.customColumns.hasOwnProperty(key)){
					var column = this.customColumns[key];
					if ("sort" in column && "sort" in options && options.sort !== null && options.sort.length > 0 && options.sort[0].attribute == key) {
						delete options["sort"];
						break;
					}
				}
			}
		}
		return new QueryResults(this.queryEngine(query, options)(list));
	}
});

});